/***************************************************************************

  TSkewedGss.h

  Author: Bastian M. Wojek
  e-mail: bastian.wojek@psi.ch

  2009/01/24

***************************************************************************/

/***************************************************************************
 *   Copyright (C) 2009 by Bastian M. Wojek                                *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _TSkewedGss_H_
#define _TSkewedGss_H_

#include "PUserFcnBase.h"
#include "TPofTCalc.h"

class TSkewedGss : public PUserFcnBase {

public:
  // default constructor
  TSkewedGss();
  ~TSkewedGss();

  double operator()(double, const vector<double>&) const;

private:
  mutable vector<double> fPar;
  TPofBCalc *fPofB;
  TPofTCalc *fPofT;
  mutable bool fCalcNeeded;
  mutable bool fFirstCall;
  mutable vector<double> fParForPofT;
  mutable vector<double> fParForPofB;
  string fWisdom;

  ClassDef(TSkewedGss,1)
};

#endif //_TSkewedGss_H_
